function [acc, acc_f, tracc, auroc, pre, rec, reg_acc, reg_acc_f, reg_auroc, reg_pre, reg_rec, feature_idx] = FSS_SVM_simplex (X_tr, X_tst, Y_tr, Y_tst, C, lambda1, lambda2, rho1, rho2, gamma1, gamma2,type)
auroc = 0;
acc = 0;
tracc = 0;
pre = 0;
rec = 0;

%X_tr_1 = [X_tr ones(size(X_tr,1),1)];
[alpha, beta1, flag, history] = eam_fss_simplex ([X_tr ones(size(X_tr,1),1)], Y_tr, [], lambda1, lambda2, rho1, rho2, gamma1, gamma2);
beta = beta1(1:size(X_tr,2),:);

% [dumb, idx] = sort(sum(beta.*beta,2),'descend');
% feature_idx = find(idx>0);
% [dumb, idx] = sort(sum(alpha.*alpha,2),'descend');
% sample_idx  = find(idx>0);
sample_idx = find(alpha>0);
feature_idx = find(beta>0);

X_tr_ = X_tr (sample_idx, feature_idx);
Y_tr_ = Y_tr (sample_idx, :);
X_tst_ = X_tst (:, feature_idx);
    
% SVM
try
    svmStruct = svmtrain(X_tr_,Y_tr_,'autoscale',true,'boxconstraint',C);
    svmpredictions = svmclassify (svmStruct,X_tst_);
    svmpredictions_tr = svmclassify (svmStruct,X_tr_);

    t = length((find(svmpredictions_tr == Y_tr_)));
    tracc = t/size(Y_tr_,1);

    t = length((find(svmpredictions == Y_tst)));
    acc = t/size(Y_tst,1);

    shift = svmStruct.ScaleData.shift;
    scale = svmStruct.ScaleData.scaleFactor;
    Xnew = bsxfun(@plus,X_tst_,shift);
    Xnew = bsxfun(@times,Xnew,scale);
    sv = svmStruct.SupportVectors;
    alphaHat = svmStruct.Alpha;
    bias = svmStruct.Bias;
    kfun = svmStruct.KernelFunction;
    kfunargs = svmStruct.KernelFunctionArgs;
    f = kfun(sv,Xnew,kfunargs{:})'*alphaHat(:) + bias;
    f = -f; % flip the sign to get the score for the +1 class
    [XX, YY, TT, auroc, OPTROCPT, SUBY, SUBYNAMES] = perfcurve(Y_tst,f, '1');
    aa = find(YY==OPTROCPT(2));
    bb = find(XX==OPTROCPT(1));
    cc = intersect (aa, bb);

    f(f >= TT(cc)) = 1;
    f(f < TT(cc)) = type;
    acc_f = sum(f == Y_tst) / size(Y_tst,1);
    %acc = max (acc, acc_1);

    pre = XX(cc);
    rec = YY(cc);

catch err
    fprintf ('Error training the svm...\n');%'%s\n', getReport(err));
    acc = -1;
    acc_f = -1;
    tracc = -1;
    auroc = -1;
    pre = -1;
    rec = -1;
    %return;
end

% calculating the regression accuracy and other metrics

Y_pre1 = [X_tr ones(size(X_tr,1),1)] * beta1;
Y_pre1 = -Y_pre1;
[XX, YY, TT, ~, OPTROCPT] = perfcurve(Y_tr,Y_pre1, '1');
aa = find(YY==OPTROCPT(2));
bb = find(XX==OPTROCPT(1));
cc = intersect (aa, bb);
thresh = TT(cc);

Y_pre = [X_tst ones(size(X_tst,1),1)] * beta1;
Y_pre = -Y_pre;
[XX, YY, TT, reg_auroc, OPTROCPT, SUBY, SUBYNAMES] = perfcurve(Y_tst,Y_pre, '1');
aa = find(YY==OPTROCPT(2));
bb = find(XX==OPTROCPT(1));
cc = intersect (aa, bb);

Y_pre(Y_pre >= thresh) = 1;
Y_pre(Y_pre < thresh) = type;
reg_acc = sum(Y_pre == Y_tst) / size(Y_tst,1);

Y_pre(Y_pre >= TT(cc)) = 1;
Y_pre(Y_pre < TT(cc)) = type;
reg_acc_f = sum(Y_pre == Y_tst) / size(Y_tst,1);

reg_pre = XX(cc);
reg_rec = YY(cc);

end