
clear
close all

save_name = 'results_svm_fss_simplex_98roi_alldata_run2';
lambda_1 = [0.01 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.75 0.8 0.85 0.9 0.95];
lambda_2 = [0.01 0.05 0.1 0.15 0.2 0.25 0.3 0.35 0.4];
rho    = [1 1.1 1.5];
gamma  = [1];
featureNumSelects = [100];%[50 100 150 200 250];
sampleNumSelects = [100];%[60 80 100];
Cs = [1];

K = 10; % Number of folds
type = 0; % -1 % the value for the first class

numSamples = 543; % Number of samples
numFeatures = 294; % Number of features


% Addpath for SLEP package
addpath '~/Dropbox/UNC/Codes/SLEP/SLEP_package_4.1/SLEP/functions/L1Lq/Lq1R/';
addpath '~/Dropbox/UNC/Codes/SLEP/SLEP_package_4.1/SLEP/functions/L1/L1R/';
addpath '~/Dropbox/UNC/Codes/SLEP/SLEP_package_4.1/SLEP/opts/';
addpath '~/Dropbox/UNC/Codes/SLEP/SLEP_package_4.1/SLEP/CFiles/q1/';

% LS-CCA
addpath '/Users/ehsanadeli/Dropbox/UNC/Codes/CCA/package/utilities'

% Addpath for Simplex
addpath '/Users/ehsanadeli/Dropbox/UNC/UNC-Research/Sparse Simplex/markSchmidt/minConf'
addpath '/Users/ehsanadeli/Dropbox/UNC/UNC-Research/Sparse Simplex/markSchmidt/misc'
addpath '/Users/ehsanadeli/Dropbox/UNC/UNC-Research/Sparse Simplex/markSchmidt/lossFuncs'
addpath '/Users/ehsanadeli/Dropbox/UNC/UNC-Research/Sparse Simplex/markSchmidt/minFunc'

% PPMI Data path
%dataPath_ROI90   = '/Users/ehsanadeli/Dropbox/UNC/PPMI/Dataset/roi90.mat';
%dataPath_ROI1091 = '/Users/ehsanadeli/Dropbox/UNC/PPMI/Dataset/roi1091.mat';
%dataPath_ROIall = '/Users/ehsanadeli/Dropbox/UNC/Dataset/PPMI_56PD_56NC/PPMI112_data.mat';
dataPath_ROIall = '/Users/ehsanadeli/Dropbox/UNC/Dataset/PPMI_Full/PPMI_Full.mat';

load (dataPath_ROIall);

%[X_tr,Y_tr,X_tst,Y_tst] = generate_data(true);

%NC98 = [NC90 NC8];
%PD98 = [PD90 PD8];

X = [NC98' PD98'];
Y = [ones(1,169) ones(1,374)*(type)];

% Normalizing the white and grey matter features
for i = 1:numSamples
    s = sum(X(:,i));
    a = X(:,i) * 1000;
    X(:,i) = a / s;
    mm = min(min(X(:,i)));
    MM = max(max(X(:,i)));
    X(:,i) = (X(:,i) - mm) / (MM - mm);
end
aa = randperm(numSamples);
X(:,:) = X(:,aa);
Y(:,:) = Y(:,aa);

X = colCenter(X);
% Y = colCenter(Y);

indices = crossvalind('Kfold',numSamples,K);

data = cell(K,4);
for cv = 1:K
    data{cv,1} = X(:,indices ~= cv);
    data{cv,2} = X(:,indices == cv);
    data{cv,3} = Y(:,indices ~= cv);
    data{cv,4} = Y(:,indices == cv);
end

results_svm = struct('acc',{},'acc_f',{},'tracc', {}, 'auroc',{}, 'pre', {}, 'rec', {}, 'reg_acc',{}, 'reg_acc_f',{}, 'reg_auroc',{}, 'reg_pre', {}, 'reg_rec', {}, 'C',{},'lambda1',{},'lambda2',{},'rho1',{},'rho2',{},'gamma1',{},'gamma2',{},'selected_features',{});%,'kernelParam',{});

iter = 0;
%for featureNumSelect = featureNumSelects
 %   for sampleNumSelect = sampleNumSelects
        for C = Cs
            for lambda1 = lambda_1
                 for lambda2 = lambda_2
                    for rho1 = rho
%                         for rho2 = rho
                           for gamma1 = gamma
%                                for gamma2 = gamma
                                    gamma2 = gamma1;
                                    rho2 = rho1;
                                    %lambda2 = max(lambda1, 1);
                                    
                                    svm_acc_f = 0; svm_acc = 0; svm_tracc = 0; svm_auroc = 0; svm_pre = 0; svm_rec = 0;
                                    reg_acc_f = 0; reg_acc = 0; reg_auroc = 0; reg_pre = 0; reg_rec = 0;
                                    selected_features = zeros (1, numFeatures);

                                    for cv = 1:K
                                        [acc, acc_f, tracc, auroc, pre, rec, reg_acc1, reg_acc1_f, reg_auroc1, reg_pre1, reg_rec1, features_idx] = FSS_SVM_simplex (data{cv,1}',data{cv,2}',data{cv,3}',data{cv,4}', C, lambda1, lambda2, rho1, rho2, gamma1, gamma2, type);
                                        svm_acc   = svm_acc + acc;
                                        svm_acc_f   = svm_acc_f + acc_f;
                                        svm_tracc = svm_tracc + tracc;
                                        svm_auroc = svm_auroc + auroc;
                                        svm_pre = svm_pre + pre;
                                        svm_rec = svm_rec + rec;
                                        
                                        reg_acc = reg_acc + reg_acc1;
                                        reg_acc_f = reg_acc_f + reg_acc1_f;
                                        reg_auroc = reg_auroc + reg_auroc1;
                                        reg_pre = reg_pre + reg_pre1;
                                        reg_rec = reg_rec + reg_rec1;
                                        
                                        selected_features(features_idx) = selected_features(features_idx) + 1;
                                    end
                                    
                                    res.acc     = svm_acc/K;
                                    res.acc_f   = svm_acc_f/K;
                                    res.tracc   = svm_tracc/K;
                                    res.auroc   = svm_auroc/K;
                                    res.pre     = svm_pre/K;
                                    res.rec     = svm_rec/K;
                                    
                                    res.reg_acc     = reg_acc/K;
                                    res.reg_acc_f   = reg_acc_f/K;
                                    res.reg_auroc   = reg_auroc/K;
                                    res.reg_pre     = reg_pre/K;
                                    res.reg_rec     = reg_rec/K;

                                    res.C       = C;
                                    res.lambda1 = lambda1;
                                    res.lambda2 = lambda2;
                                    res.rho1    = rho1;
                                    res.rho2    = rho2;
                                    res.gamma1  = gamma1;
                                    res.gamma2  = gamma2;
                                    res.selected_features = selected_features;


                                    results_svm = [results_svm, res];
                                    fprintf ('Done %d: acc=%.4f, tracc=%.4f\n', iter, res.acc, res.tracc); 
                                    iter = iter + 1;
%                                end
                            end
%                         end
                    end
                end
            end
        end
%    end
%end
                            
    
maxxx = 0;
for i = 1:length(results_svm)
    if (maxxx < results_svm(i).acc)
        maxxx = results_svm(i).acc;
        max_idx = i;
    end
end

save (['results/' save_name],'results_svm','data');
save (['results/' save_name '_all']);

results_svm(max_idx)
